#!/bin/perl

#####################################
#                                   #
# RobAdmin v2.0                     #
# Copyright 1998 by Rob Eisler      #
# rob@robplanet.com                 #
# http://www.robplanet.com          #
#                                   #
# Last modified on June 15, 1998    #
#                                   #
#####################################
#
# Copyright Notice:
# Copyright 1998 Robert S. Eisler.  All Rights Reserved.
#
# This code may be used and modified by anyone so long as this header and
# copyright information remains intact.  By using this code you agree to 
# indemnify Robert S. Eisler from any liability that might arise from its 
# use.  You must obtain written consent before selling or redistributing 
# this code.
#
# You should have received the file readme.txt with this distribution.
# If not, please let me know where you obtained this copy of RobLog by 
# sending mail to eislerr@tdi.uregina.ca .  The newest version of 
# readme.txt is always available at:
# http://tdi.uregina.ca/~eislerr/cgi/roblog/readme.txt
# Please see this file for further information.
#
#####################################

# declare the variables
$logdir = '/path/to/your/roblog/directory';
$logurl = 'http://www.yourhost.com/~you/roblog';
$timeoffset = 0;

#########################################################################
# Don't change anything below here unless you know what you're doing :) #
#########################################################################

$use_cgi = 1;
$crash = "Nothing";
$flag = 0;

print "Content-type: text/html\n\n";

&get_date;

read(STDIN, $input, $ENV{'CONTENT_LENGTH'});

@pairs = split(/&/, $input);
foreach $pair (@pairs) {

	($name, $value) = split(/=/, $pair);
	
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	$value =~ s/<!--(.|\n)*-->//g;
	$FORM{$name} = $value;
}

$change_max = $FORM{'change_max'};
$max = $FORM{'max'};
$change = $FORM{'change'};
$newpass1 = $FORM{'newpass1'};
$newpass2 = $FORM{'newpass2'};
$formlog = $FORM{'log'};
$formhour = $FORM{'hour'};
$formweek = $FORM{'week'};
$formip = $FORM{'ip'};
$formbr = $FORM{'browser'};
$formos = $FORM{'os'};
$formr = $FORM{'referer'};
$formd = $FORM{'domain'};

open(FILE, "$logdir/pwd.txt") || &file_open_error_exit("pwd.txt");
@lines = <FILE>;
close(FILE);

($p, $oldmax, $ipdate, $browserdate, $osdate, $refererdate, $nochop) = split(/``/,$lines[0]);

if ($p ne crypt($FORM{'pass'}, substr($p, 0, 2))) {

# invalid password

	print "<html><head><title>Zoops!</title></head>\n";
	print "<body bgcolor = white link=#00ff00 vlink=#00ff00 text=black>\n";
	print "<center>\n";
	print "<font face=arial size=5>\n";
	print "Zoops!</font><p>\n";
	print "<font face=arial>\n";
	print "Invalid Password<p>\n";
	print "<table border=1 bgcolor=#000066 cellpadding=8>\n";
	print "<tr><td align=center width=50%><a href=\"$logurl/index.html\">RobLog Main</a></td>\n";
	print "<td align=center width=50%><a href=\"$logurl/admin.html\">RobAdmin</a></td></tr>\n"; 
	print "</table>\n";
	print "</font></center></body></html>\n";

} else {

# valid password

	print "<html><head><title>RobAdmin Complete</title></head>\n";
	print "<body bgcolor = white link=#00ff00 vlink=#00ff00 text=black>\n";
	print "<center>\n";
	print "<font face=arial size=5>\n";
	print "RobAdmin Complete</font><p>\n";
	print "</center>\n";
	print "<font face=arial>\n";
	print "These functions were performed:<br>\n";
	print "<ul>\n";

	if ($change eq 'yes' || $change_max eq 'yes') {
		&password;
		$flag = 1;
	}
	if ($formlog eq 'yes') {
		&reset_log;
		$flag = 1;
	}
	if ($formhour eq 'yes') {
		&reset_hour;
		$flag = 1;
	}
	if ($formweek eq 'yes') {
		&reset_week;
		$flag = 1;
	}
	if ($formip eq 'yes') {
		&reset_ip;
		$flag = 1;
	}
	if ($formbr eq 'yes') {
		&reset_browser;
		$flag = 1;
	}
	if ($formos eq 'yes') {
		&reset_os;
		$flag = 1;
	}
	if ($formr eq 'yes') {
		&reset_referer;
		$flag = 1;
	}
	if ($formd eq 'yes') {
		&reset_domain;
		$flag = 1;
	}

	if ($flag == 0) {
		print "<li>What a waste - I didn't do anything!\n";
	}

	print "</ul>\n";
	print "<center>\n";
	print "<table border=1 bgcolor=#000066 cellpadding=8>\n";
	print "<tr><td align=center width=50%><a href=\"$logurl/index.html\">RobLog Main</a></td>\n";
	print "<td align=center width=50%><a href=\"$logurl/admin.html\">RobAdmin</a></td></tr>\n";
	print "</table>\n";
	print "</font></center></body></html>\n";

}

sub password {

	local($write_pass) = $p;
	local($write_max) = $oldmax;
	local($write_ip) = $ipdate;
	local($write_br) = $browserdate;
	local($write_os) = $osdate;
	local($write_re) = $refererdate;

	if ($change eq 'yes') {
		if ($newpass1 ne $newpass2) {
			print "<li>The 2 new password fields do not match - password not changed\n";
		}
		else {
			if ($newpass1 eq '') {
				print "<li>You did not enter a new password - password not changed\n";
			} else {
				$write_pass = crypt($newpass1, substr($p, 0, 2));
				print "<li>Password changed\n";
			}
		}
	}

	if ($change_max eq 'yes') {
		if ($max) {
			$write_max = $max;
			print "<li>Max log hits changed\n";
		} else {
			print "<li>Max log hits not changed\n";
		}
	}

	$write_ip = $date if ($formip eq 'yes');
	$write_br = $date if ($formbr eq 'yes');
	$write_os = $date if ($formos eq 'yes');
	$write_re = $date if ($formr eq 'yes');
	open(FILE, ">$logdir/pwd.txt") || &file_open_error_exit("pwd.txt");
	print FILE "$write_pass``$write_max``$write_ip``$write_br``$write_os``$write_re``xx";
	close(FILE);

}

sub reset_log {

	open (FILE, ">$logdir/log.htm") || &file_open_error("log.htm");

	&header("Access Log");
	print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n\n";
	print FILE "<!--begin-->\n";
	print FILE "<tr><th colspan=3><font face=arial size=+1>Log reset on $date</font></th></tr>\n";
	print FILE "<!--end-->\n";
	print FILE "</table><p>\n";
	print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
	print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
	print FILE "</table>\n";
	print FILE "</font></center></body></html>\n";

	close(FILE);

	print "<li>Log file reset\n" if ($crash ne 'log.htm');

}

sub reset_hour {

	open(FILE, ">$logdir/hour.html") || &file_open_error("hour.html");

	&header("Hits by Hour");
	print FILE "<font face=\"comic sans ms\" size=0 color=black>Hourly stats reset on $date</font><p>\n";
	print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
	print FILE "<tr><th>HOUR</th>";
	print FILE "<th width=15%>HITS</th>";
	print FILE "<th width=15%>PERCENT</th>";

	for ($a = 0; $a <= 23; $a++) {

		$temp = $a + 1;
		print FILE "<tr><th>$a:00 - $temp:00</th>";
		print FILE "<td align=center>0</td>";
		print FILE "<td align=center>0%</td></tr>\n";

	}

	print FILE "<tr><th>TOTAL</th>";
	print FILE "<th>0</th><th>0%</th></tr>\n";
	print FILE "</table><p>\n";
	print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
	print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
	print FILE "</table>\n";
	print FILE "</font></center></body></html>\n";

	close(FILE);

	open(FILE, ">$logdir/hour.txt") || &file_open_error("hour.txt");

	print FILE "0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``0``$date";

	close(FILE);

	print "<li>Hourly stats reset\n" if ($crash ne 'hour.txt' && $crash ne 'hour.html');

}

sub reset_week {

	open(FILE, ">$logdir/weekday.html") || &file_open_error("weekday.html");

	&header("Hits by Weekday");
	print FILE "<font face=\"comic sans ms\" size=0 color=black>Weekday stats reset on $date</font><p>\n";
	print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
	print FILE "<tr><th>HOUR</th>";
	print FILE "<th width=15%>HITS</th>";
	print FILE "<th width=15%>PERCENT</th>";
	print FILE "<tr><th>Sunday</th>";
	print FILE "<td align=center>0</td>";
	print FILE "<td align=center>0%</td></tr>\n";
	print FILE "<tr><th>Monday</th><td align=center>0</td>";
	print FILE "<td align=center>0%</td></tr>\n";
	print FILE "<tr><th>Tuesday</th><td align=center>0</td>";
	print FILE "<td align=center>0%</td></tr>\n";
	print FILE "<tr><th>Wednesday</th><td align=center>0</td>";
	print FILE "<td align=center>0%</td></tr>\n";
	print FILE "<tr><th>Thursday</th><td align=center>0</td>";
	print FILE "<td align=center>0%</td></tr>\n";
	print FILE "<tr><th>Friday</th><td align=center>0</td>";
	print FILE "<td align=center>0%</td></tr>\n";
	print FILE "<tr><th>Saturday</th><td align=center>0</td>";
	print FILE "<td align=center>0%</td></tr>\n";
	print FILE "</table><p>\n";
	print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
	print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
	print FILE "</table>\n";
	print FILE "</font></center></body></html>\n";

	close(FILE);

	open(FILE, ">$logdir/weekday.txt") || &file_open_error("weekday.txt");

	print FILE "0``0``0``0``0``0``0``$date";

	close(FILE);

	print "<li>Weekday stats reset\n" if ($crash ne 'weekday.txt' && $crash ne 'weekday.html');

}

sub reset_ip {

	open (FILE, ">$logdir/ip.html") || &file_open_error("ip.html");

	&header("Hits by IP");
	print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n\n";
	print FILE "<tr><th colspan=3><font face=arial size=+1>Reset on $date</font></th></tr>\n";
	print FILE "</table><p>\n";
	print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
	print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
	print FILE "</table>\n";
	print FILE "</font></center></body></html>\n";

	close(FILE);

	open(FILE, ">$logdir/ip.txt") || &file_open_error("ip.txt");

	print FILE "  ";

	close(FILE);

	print "<li>IP stats reset\n" if ($crash ne 'ip.txt' && $crash ne 'ip.html');

}

sub reset_browser {

        open (FILE, ">$logdir/browser.html") || &file_open_error("browser.html");

	&header("Hits by Browser");
        print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
        print FILE "<tr><th colspan=3><font face=arial size=+1>Reset on $date</font></th></tr>\n";
        print FILE "</table><p>\n";
	print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
	print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
	print FILE "</table>\n";
        print FILE "</font></center></body></html>\n";

	close (FILE);

        open(FILE, ">$logdir/browser.txt") || &file_open_error("browser.txt");

        print FILE "Mozilla4``0``xxx\n";
	print FILE "Mozilla3``0``xxx\n";
	print FILE "Mozilla2``0``xxx\n";
	print FILE "Mozilla1``0``xxx\n";
        print FILE "Explorer4``0``xxx\n";
	print FILE "Explorer3``0``xxx\n";
	print FILE "Explorer2``0``xxx\n";
	print FILE "Explorer1``0``xxx\n";
        print FILE "Lynx``0``xxx\n";
        print FILE "Unknown``0``xxx\n";

        close(FILE);

	print "<li>Browser stats reset\n" if ($crash ne 'browser.txt' && $crash ne 'browser.html');

}

sub reset_os {

        open (FILE, ">$logdir/os.html") || &file_open_error("os.html");

	&header("Hits by Operating System");
        print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
        print FILE "<tr><th colspan=3><font face=arial size=+1>Reset on $date</font></th></tr>\n";
        print FILE "</table><p>\n";
	print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
	print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
	print FILE "</table>\n";
        print FILE "</font></center></body></html>\n";

        close(FILE);

        open(FILE, ">$logdir/os.txt") || &file_open_error("os.txt");

	print FILE "Windows 95``0``xxx\n";
	print FILE "Windows NT``0``xxx\n";
	print FILE "Macintosh``0``xxx\n";
	print FILE "Unix``0``xxx\n";
	print FILE "Windows 3.1``0``xxx\n";
        print FILE "Win 16``0``xxx\n";
	print FILE "Unknown``0``xxx\n";

        close(FILE);

	print "<li>OS stats reset\n" if ($crash ne 'os.txt' && $crash ne 'os.html');

}

sub reset_referer {

        open (FILE, ">$logdir/referer.html") || &file_open_error("referer.html");

	&header("Hits by Referer");
        print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
        print FILE "<tr><th colspan=3><font face=arial size=+1>Reset on $date</font></th></tr>\n";
        print FILE "</table><p>\n";
	print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
	print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
	print FILE "</table>\n";
        print FILE "</font></center></body></html>\n";

        close(FILE);

        open(FILE, ">$logdir/referer.txt") || &file_open_error("referer.txt");

        print FILE "  ";

        close(FILE);

	print "<li>Referer stats reset\n" if ($crash ne 'referer.txt' && $crash ne 'referer.html');

}

sub reset_domain {

        open (FILE, ">$logdir/server.html") || &file_open_error("server.html");

        &header("Hits by Domain Extension");
        print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
        print FILE "<tr><th colspan=3><font face=arial size=+1>Reset on $date</font></th></tr>\n";
        print FILE "</table><p>\n";
        print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
        print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
        print FILE "</table>\n";
        print FILE "</font></center></body></html>\n";

        close(FILE);

        open(FILE, ">$logdir/server.txt") || &file_open_error("server.txt");

	for ($a = 0; $a < 248; $a++) {
		print FILE "0``";
	}
        print FILE "x\n";

        close(FILE); 

        print "<li>Domain stats reset\n" if ($crash ne 'server.txt' && $crash ne 'server.html');

}

sub header {

        local($passed) = @_;

        print FILE "<html>\n";
        print FILE "<head><title>RobLog v4.02 - $passed</title></head>\n\n";
        print FILE "<!--\n";
        print FILE "RobLog v4.02 Copyright 1998 by Rob Eisler\n";
        print FILE "eislerr\@tdi.uregina.ca\n";
        print FILE "http://tdi.uregina.ca/~eislerr\n";
	print FILE "http://tdi.uregina.ca/~eislerr/cgi/roblog\n";
        print FILE "-->\n\n";
        print FILE "<body bgcolor=#ffffff link=#00ff00 vlink=#00ff00 text=#dddddd>\n";
        print FILE "<center>\n";
        print FILE "<font face=arial size=5 color=black>RobLog v4.02 - $passed</font><p>\n";

}

sub get_date {

        @days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
        @months = ('January','February','March','April','May','June','July','August','September','October','November','December');

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time + (3600*$timeoffset));

	$savehour = $hour;
	if ($hour < 10) { $hour = "0$hour"; }
	if ($min < 10) { $min = "0$min"; }
	if ($sec < 10) { $sec = "0$sec"; }
	$year = 1900 + $year;

	$date = "$days[$wday], $months[$mon] $mday, $year at $hour\:$min\:$sec";

}

sub file_open_error {

	local($file) = @_;
	print "<li><b>Error!</b> Unable to open $file - <b>$file not changed!</b>\n";
	$crash = $file;

}

sub file_open_error_exit {

	local($file) = @_;
	print "<li><b>Error!</b> Unable to open $file - <b>Aborting RobAdmin</b></li></ul><p>\n";
	print "<center>\n";
        print "<table border=1 cellpadding=8>\n";
        print "<tr><td align=center width=50%><a href=\"$logurl/index.html\">RobLog Main</a></td>\n";
        print "<td align=center width=50%><a href=\"$logurl/admin.html\">RobAdmin</a></td></tr>\n";
        print "</table>\n";
	print "</html>\n";

	exit;

}
